# ============================================================================= #
# >> Useful Information About The Plugin
# ============================================================================= #
# This plugin can be used to benefit certain players.
# Default Settings.:
# Everybody inside the SpPlayers, will have access to the !benefit command.
# This allows them to choose between the following entities:
# 1. Receive 125 HP.
# 2. Receive 1 HE Grenade.
# 3. Receive a Flashbang.
# 4. Receive a USP with a 12 clip magazine.
# ============================================================================= #
# >> IMPORTS
# ============================================================================= #
import cmdlib
import es
from es import AddonInfo, getAddonPath
from path import path
import cfglib
import playerlib
import popuplib
import psyco
psyco.full()
# ============================================================================= #
# >> Addon Info
# ============================================================================= #
info = es.AddonInfo()
info.name     = "Benefit"
info.version  = "1.3.85"
info.url      = "http://www.addons.eventscripts.com/addons/view/simplebenefit"
info.author   = "Fridge"
info.description = "Capable of providing predefined benefit methods for certain players.."
# ============================================================================= # 
# >> Configuration Function
# ============================================================================= #
config = cfglib.AddonCFG(getAddonPath("benefit") + "/cfg/config.cfg")

config.text("******************************")
config.text("  BENEFIT CONFIGURATION START")
config.text("******************************")

benefit_switch     = config.cvar("benefit_enable",     1, "Enable/disable Fridge's Benefit")

config.text("******************************")
config.text("  BENEFIT CONFIGURATION END")
config.text("******************************")

config.write()
# ============================================================================= #
# >> Group Assignment with STEAM_X:X:XXXXXXXX, Seperate with a space and a ,
# ============================================================================= #
SpPlayers = ['STEAM_0:0:51207736', 'STEAM_0:0:66884913', 'STEAM_X:X:XXXXXXXX']
# ============================================================================= #
# >> Sound Effects
# ============================================================================= #
soundList = ['accessgranted.mp3','accessdenied.mp3','activate.mp3','deactivate.mp3','menuexit.wav','menuopen.wav']
soundDir = 'fridge_music/'
# ============================================================================= #
# >> Download If Not Already Function
# ============================================================================= #
def addSounds():
    for soundTitle in soundList:
	es.stringtable('downloadables', 'sound/' + soundDir + soundTitle)
	
def es_map_start(event_var):
    addSounds()
# ============================================================================= #
# >> Load & Unload Function
# ============================================================================= #
def load():
    cmdlib.registerSayCommand('!benefit', benefitCmd, 'A menu that can provide all sorts of benefits for the player.')
    cmdlib.registerSayCommand('!credits', creditsFunc, 'Credits')
    config.execute() 
    
def unload():
    cmdlib.unregisterSayCommand('!benefit')
    cmdlib.unregisterSayCommand('!credits')
# ============================================================================= #
# >> benefitCmd Menu
# ============================================================================= #
def benefitCmd(userid, args):
    uid = es.getplayersteamid(userid)
    dead = es.getplayerprop(userid, 'CBasePlayer.pl.deadflag')
    menu = popuplib.create('user_menu')
    if not dead and uid in SpPlayers:
        menu.addline('Benefit Menu')
        menu.addline(' ')
        menu.addline('->1. Receive 125HP')
        menu.addline('->2. Receive a HE Grenade')
        menu.addline('->3. Receive a Flashbang')
        menu.addline('->4. Receive USP')
        menu.addline(' ')
        menu.addline('->0. Close Benefit Menu')
        menu.unsend(userid)
        menu.send(userid)
        menu.delete()
        menu.menuselect = BenefitSelect
        es.playsound(userid, 'fridge_music/accessgranted.mp3', 1.0)
        es.playsound(userid, 'fridge_music/menuopen.wav', 1.0)
    elif dead and uid in SpPlayers:
        tell(userid, 'You are either a spectator or dead.. otherwise, you would not read this..')
        es.playsound(userid, 'fridge_music/accessdenied.mp3', 1.0)
        es.playsound(userid, 'fridge_music/deactivate.mp3', 1.0)
    else:
        es.tell(userid, '#multi', '\x07000000[\x07FFEA00RCON\x07000000] \x07FF0000You are not authorized to run this command.')
        es.playsound(userid, 'fridge_music/accessdenied.mp3', 1.0)
        es.playsound(userid, 'fridge_music/deactivate.mp3', 1.0)
# ============================================================================= #
# >> Credits Menu
# ============================================================================= #
def creditsFunc(userid, args):
    cred = popuplib.create('user_menu')
    cred.addline('Credits')
    cred.addline(' ')
    cred.addline('->1. Developer & Publisher')
    cred.addline(' ')
    cred.addline('->0. Close Credits')
    cred.unsend(userid)
    cred.send(userid)
    cred.delete()
    cred.menuselect = credSelect
    es.playsound(userid, 'fridge_music/accessgranted.mp3', 1.0)
    es.playsound(userid, 'fridge_music/menuopen.wav', 1.0)
# ============================================================================= #
# >> Plugin Prefix/Tag/Suffix Function
# ============================================================================= #
def tell(userid, text):
    es.tell(userid, '#multi', '\x07FF9933[\x07FF6633Benefit\x0786F024++\x07FF9933] \x0786F024 ' + text)
# ============================================================================= #
# >> Benefit Selection Function
# ============================================================================= #
def BenefitSelect(userid, choice, popupid):
    player = playerlib.getPlayer(userid)
    uid = es.getplayersteamid(userid)
    dead = es.getplayerprop(userid, 'CBasePlayer.pl.deadflag')
    if not dead and choice == 1:
        es.setplayerprop(userid, "CBasePlayer.m_iHealth", 125)
        tell(userid, 'Your health has been modified to 125.')
        es.playsound(userid, 'fridge_music/activate.mp3', 1.0)
    elif not dead and choice == 2:
        if player.getHE() is (0):
            es.server.queuecmd('es_xgive %s weapon_hegrenade' % userid)
            es.playsound(userid, 'fridge_music/activate.mp3', 1.0)
            tell(userid, 'You have received a HE Grenade.')
        else:
            tell(userid, 'You have the maximum amount of HE Grenades.')
            es.playsound(userid, 'fridge_music/deactivate.mp3', 1.0)
            es.playsound(userid, 'fridge_music/menuexit.wav', 1.0)
    elif not dead and choice == 3:
        if player.getFB() in (0, 1):
            es.server.queuecmd('es_xgive %s weapon_flashbang' % userid)
            tell(userid, 'You have received a flashbang.')
            es.playsound(userid, 'fridge_music/activate.mp3', 1.0)
        else:
            tell(userid, 'You have the maximum amount of flashbangs.')
            es.playsound(userid, 'fridge_music/deactivate.mp3', 1.0)
            es.playsound(userid, 'fridge_music/menuexit.wav', 1.0)
    elif not dead and choice == 4:
        if player.getSecondary() == 0:
            es.server.queuecmd('es_xgive %s weapon_usp' % userid)
            tell(userid, 'You have received a USP.')
            tell(userid, 'There will be a clip modification coming very soon.')
            es.playsound(userid, 'fridge_music/activate.mp3', 1.0)
        else:
            tell(userid, 'You already have a secondary weapon.')
            es.playsound(userid, 'fridge_music/deactivate.mp3', 1.0)
            es.playsound(userid, 'fridge_music/menuexit.wav', 1.0)
# ============================================================================= #
# >> Credits Function
# ============================================================================= #
def credSelect(userid, choice, popupid):
    if choice == 1:
	es.tell(userid, '#multi', '\x0786F024[\x07FF6633RCON\x0786F024] \x0786F024Plugin Developer & Publisher: \x07FF6633Fridge')
        es.playsound(userid, 'fridge_music/activate.mp3', 1.0)
        es.playsound(userid, 'fridge_music/deactivate.mp3', 1.0)